; 
; 
; #########################################################################
;                     COMPILER DIRECTIVES
; #########################################################################
; 
; 
.586                      ; create 32 bit code
.model flat, stdcall      ; 32 bit memory model
option casemap :none      ; Case Sensitive
; 
; #########################################################################
;                     INCLUDE FILES
; #########################################################################
; 
    include \masm32\include\windows.inc
    include \masm32\INCLUDE\dialogs.inc
    ;include \masm32\include\masm32.inc
    ;
    include \masm32\include\advapi32.inc
    include \masm32\include\comdlg32.inc
    include \masm32\include\gdi32.inc
    include \masm32\include\kernel32.inc
    include \masm32\include\oleaut32.inc
    include \masm32\include\shell32.inc
    include \masm32\include\user32.inc
    ;
    ;include \masm32\include\ole32.inc
    ;include \masm32\include\mpr.inc
    include \masm32\include\Comctl32.inc
    ;include \masm32\include\shell32.inc
    include \masm32\include\version.inc


;     libraries
;     ~~~~~~~~~
    ;includelib \masm32\lib\masm32.lib
    ;
    includelib \masm32\lib\advapi32.lib
    includelib \masm32\lib\comdlg32.lib
    includelib \masm32\lib\gdi32.lib
    includelib \masm32\lib\kernel32.lib
    includelib \masm32\lib\oleaut32.lib
    includelib \masm32\lib\shell32.lib
    includelib \masm32\lib\user32.lib
    ;
    ;includelib \masm32\lib\mpr.lib
    includelib \masm32\lib\Comctl32.lib
    ;includelib \masm32\lib\shell32.lib
    includelib \masm32\lib\version.lib
    ;
    include macros.inc

; 
; #########################################################################
                    ;GLOBAL FUNCTIONS
; #########################################################################
; 
    wsprintfA                   PROTO C :DWORD,:VARARG
    wsprintf                    equ <wsprintfA>
    ;
    ;main                        PROTO :DWORD,:DWORD
    mainDlgProc                 PROTO :DWORD,:DWORD,:DWORD,:DWORD
    mainDlgTab1                 PROTO :DWORD,:DWORD
    mainDlgTab2                 PROTO :DWORD,:DWORD
    mainDlgTab3                 PROTO :DWORD,:DWORD    
    mainDlgTabProc             PROTO :DWORD,:DWORD,:DWORD,:DWORD        
    ;
    ;
; 
; #########################################################################
                    ;EQUATES
; #########################################################################
; 
.const
    ;
    ;
    EQU_TAB                     equ 1
    EQU_TAB1                    equ 2
    EQU_GROUP1                  equ 3
    EQU_PROMPT01                equ 4
    EQU_EDITBOX01               equ 5        
    EQU_TAB2                    equ 6
    EQU_GROUP2                  equ 7
    EQU_PROMPT02                equ 8
    EQU_EDITBOX02               equ 9 
    ;
; 
; #########################################################################
                    ;INITIALIZED DATA SECTION
; #########################################################################
; 
.data
                  ;
    ;comCtrls                    INITCOMMONCONTROLSEX <0>
    szTab1                      db 'Tab1',0
    szTab2                      db 'Tab2',0
; 
; #########################################################################
                    ;UNITIALIZED DATA SECTION
; #########################################################################
; 
.data?
    hInstance                   dd ?
    hWinMain                   dd ?
    hIcon                       dd ?
    ;
    hTab                        dd ?  
    ;
    ;
    ;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
    ;
    ;
    ;TVITEMA                     STRUCT
    ;                                _mask             DWORD  ?
    ;                                hItem             DWORD  ?
    ;                                state             DWORD  ?
    ;                                stateMask         DWORD  ?
    ;                                pszText           DWORD  ?
    ;                                cchTextMax        DWORD  ?
    ;                                iImage            DWORD  ?
    ;                                iSelectedImage    DWORD  ?
    ;                                cChildren         DWORD  ?
    ;                                lParam            DWORD  ?
    ;TVITEMA                     ENDS
   ;
   ; TVITEM                      equ <TVITEMA>
    ;TV_ITEM                     equ <TVITEMA>
    ;
    ;TV_ITEMEX                   STRUCT
    ;                                imask             DWORD      ?
    ;                                hItem             DWORD      ?
    ;                                state             DWORD      ?
    ;                                stateMask         DWORD      ?
    ;                                pszText           DWORD      ?
    ;                                cchTextMax        DWORD      ?
    ;                                iImage            DWORD      ?
    ;                                iSelectedImage    DWORD      ?
    ;                                cChildren         DWORD      ?
    ;                                lParam            DWORD      ?
    ;                                iIntegral         DWORD      ?
    ;TV_ITEMEX                   ENDS
   ;
   ; TVITEMEX                    equ  <TV_ITEMEX>
   ;
   ; ITEMTYPE                    UNION
   ;                                 itemex TVITEMEX    <>
   ;                                 item TVITEM        <>
   ; ITEMTYPE                    ENDS
   ;
   ; TV_INSERTSTRUCT             STRUCT
   ;                                 hParent       DWORD      ?
   ;                                 hInsertAfter  DWORD ?
   ;                                 ITEMTYPE           <>
   ; TV_INSERTSTRUCT             ENDS
   ;
   ; TV_HITTESTINFO              STRUCT
   ;                                 pt        POINT      <>
   ;                                 flags     DWORD      ?
   ;                                 hItem     DWORD      ?
   ; TV_HITTESTINFO E            NDS
   ;
   ; TVHITTESTINFO  equ  <TV_HITTESTINFO>
    ;
    tvis                        TV_INSERTSTRUCT      <?>
    ;TC_ITEM STRUCT
    ;    imask             DWORD      ?
    ;    lpReserved1       DWORD      ?
    ;    lpReserved2       DWORD      ?
    ;    pszText           DWORD      ?
    ;    cchTextMax        DWORD      ?
    ;    iImage            DWORD      ?
    ;    lParam            DWORD      ?
    ;TC_ITEM ENDS
    ;NM_TREEVIEW STRUCT
    ;  hdr       NMHDR      <>
    ;  action    DWORD      ?
    ;  itemOld   TVITEM      <>
    ;  itemNew   TVITEM      <>
    ;  ptDrag    POINT      <>
    ;NM_TREEVIEW ENDS
    tie                         TC_ITEM             <?>
    tvi                         TV_ITEM             <?>

; 
; #########################################################################
                    ;PROGRAM ENTRY POINT
; #########################################################################
; 
.code
start:

    mov hInstance, FUNC(GetModuleHandle,NULL)
    mov hIcon,     FUNC(LoadIcon,hInstance,500)
    Invoke InitCommonControls
    ;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    call main
    Invoke ExitProcess,eax
; 
; 
; #########################################################################
;                          WINMAIN
; #########################################################################
; 
; 
align 4
main                            proc
                                LOCAL lpArgs:DWORD
    ;
    Invoke GlobalAlloc,GMEM_FIXED or GMEM_ZEROINIT, 32
    mov lpArgs, eax
    mov ecx,hIcon ;push hIcon
    mov dword ptr[eax],ecx ;pop [eax]    
    ;
    Dialog  "Xp TabControl","Ms Sans Serif",8, \        ; caption,font,pointsize MS Sans Serif  ;OR WS_VISIBLE  OR WS_EX_TOPMOST
            WS_OVERLAPPED OR WS_POPUP OR WS_CAPTION OR WS_SYSMENU OR WS_MINIMIZEBOX OR DS_CENTER OR WS_EX_TOPMOST, \
            1, \                                            ; control count
            0,0,270,220, \                                   ; x y co-ordinates
            8192                                             ; memory buffer size
            ;            
            DlgComCtl "SysTabControl32",WS_CHILD OR WS_CLIPSIBLINGS OR WS_VISIBLE,8,8,254,204,EQU_TAB
            ;


    CallModalDialog hInstance,0,mainDlgProc,addr lpArgs

    pop esi

    Invoke GlobalFree, lpArgs

    ret

main                            endp
; 
;                       DIALOG PROCEDURE
; 
align 4
mainDlgProc                     proc hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
    ;
    .if uMsg == WM_INITDIALOG
        ;
        mov eax,hWnd
        mov hWinMain,eax
        ;
        Invoke SetWindowLong,hWnd,GWL_USERDATA,lParam
        mov eax, lParam
        mov eax, [eax]
        Invoke SendMessage,hWnd,WM_SETICON,1,[eax]
        ;
        ;
        ;====================================================
        ;=============== TAB CONTROL RELATIVE ===============
        ;====================================================
        ;
        Invoke GetDlgItem,hWnd,EQU_TAB
        mov hTab,eax
        ;        
        mov tie.imask,TCIF_TEXT OR TCIF_PARAM	;OR TCIF_IMAGE
        ;
        mov tie.iImage,-1
        ;
        Invoke mainDlgTab1,hTab,hIcon
        mov tie.lParam,eax
        mov tie.pszText, offset szTab1
        Invoke SendDlgItemMessage, hWnd, EQU_TAB, TCM_INSERTITEM, 0, addr tie

        Invoke mainDlgTab2,hTab,hIcon
        mov tie.lParam,eax        
        mov tie.pszText, offset szTab2
        Invoke SendDlgItemMessage, hWnd, EQU_TAB, TCM_INSERTITEM, 1, addr tie
        Invoke mainDlgTab3,hTab,hIcon
        mov tie.lParam,eax   
        mov tie.pszText, offset szTab2
        Invoke SendDlgItemMessage, hWnd, EQU_TAB, TCM_INSERTITEM, 2, addr tie
        mov tie.pszText, offset szTab2
        Invoke SendDlgItemMessage, hWnd, EQU_TAB, TCM_INSERTITEM, 3, addr tie
        mov tie.pszText, offset szTab1
        Invoke SendDlgItemMessage, hWnd, EQU_TAB, TCM_INSERTITEM, 4, addr tie
        mov tie.pszText, offset szTab1
        Invoke SendDlgItemMessage, hWnd, EQU_TAB, TCM_INSERTITEM, 5, addr tie
        mov tie.pszText, offset szTab1
        Invoke SendDlgItemMessage, hWnd, EQU_TAB, TCM_INSERTITEM, 6, addr tie
        ;

    .elseif uMsg==WM_NOTIFY                                   ;WM_NOTIFY tell us when switching TABs
        mov eax, wParam                                       ;wParam == ControlID, lParam = pointer to NMHDR structure
        .if eax==EQU_TAB
            mov eax,lParam
            mov eax, ( NMHDR ptr [eax] ). code                ; make eax == "code" member of the structure
            .if eax==TCN_SELCHANGING
                invoke SendMessage,hTab,TCM_GETCURSEL,0,0     
                mov tie.imask,TCIF_PARAM
                invoke SendMessage,hTab,TCM_GETITEM,eax,addr tie
                invoke ShowWindow,tie.lParam,SW_HIDE
            .elseif eax==TCN_SELCHANGE
                invoke SendMessage,hTab,TCM_GETCURSEL,0,0     
                mov tie.imask,TCIF_PARAM                 
                invoke SendMessage,hTab,TCM_GETITEM,eax,addr tie
                invoke ShowWindow,tie.lParam,SW_SHOW
            .endif
        .endif            
    .elseif uMsg == WM_CLOSE
        quit_dialog:
        Invoke EndDialog,hWnd,0
        ;
    .endif
    NextLoop:
    xor eax, eax
    ret
mainDlgProc                     endp
;
align 4
mainDlgTab1                     proc hParent:DWORD,lpIcon:DWORD

    Dialog "Tab1","MS Sans Serif",8, \            ; caption,font,pointsize
            WS_CHILD OR WS_VISIBLE, \     ; style
            3, \                                       ; control count
            0,0,0,0, \                                 ; x y co-ordinates
            1024                                       ; memory buffer size
            DlgGroup "Tab1",12,6,232,176,EQU_GROUP1         
            DlgStatic "Text1:",WS_CHILD OR WS_VISIBLE OR 0200H OR 0200H,20,18,104,12,EQU_PROMPT01 ;01011b 01201H;0801h
            DlgEdit  WS_CHILD OR WS_BORDER OR WS_TABSTOP OR ES_AUTOHSCROLL OR ES_UPPERCASE OR 8000H,130,18,104,12,EQU_EDITBOX01            



    CallmodelessDialog hInstance,hParent,mainDlgTabProc,addr hParent

    ret

mainDlgTab1                     endp
align 4
mainDlgTab2                     proc hParent:DWORD,lpIcon:DWORD

    Dialog "Tab2","MS Sans Serif",8, \            ; caption,font,pointsize
            WS_CHILD, \     ; style
            3, \                                            ; control count
            0,0,0,0, \                                  ; x y co-ordinates
            1024                                            ; memory buffer size
            DlgGroup "Tab2",12,6,232,176,EQU_GROUP2
            DlgStatic "Text 2:",WS_CHILD OR WS_VISIBLE OR 0200H OR 0200H,20,18,104,12,EQU_PROMPT02 ;01011b 01201H;0801h
            DlgEdit  WS_CHILD OR WS_BORDER OR WS_TABSTOP OR ES_AUTOHSCROLL OR ES_UPPERCASE OR 8000H,130,18,104,12,EQU_EDITBOX02            



    CallmodelessDialog hInstance,hParent,mainDlgTabProc,addr hParent

    ret

mainDlgTab2                     endp
align 4
mainDlgTab3                     proc hParent:DWORD,lpIcon:DWORD

    Dialog "Tab3","MS Sans Serif",8, \            ; caption,font,pointsize
            WS_CHILD OR WS_BORDER, \     ; style
            0, \                                            ; control count
            0,0,0,0, \                                  ; x y co-ordinates
            1024                                            ; memory buffer size
            ;DlgGroup "Tab2",12,6,232,176,EQU_GROUP2
            ;DlgStatic "Text 2:",WS_CHILD OR WS_VISIBLE OR 0200H OR 0200H,20,18,104,12,EQU_PROMPT02 ;01011b 01201H;0801h
            ;DlgEdit  WS_CHILD OR WS_BORDER OR WS_TABSTOP OR ES_AUTOHSCROLL OR ES_UPPERCASE OR 8000H,130,18,104,12,EQU_EDITBOX02            



    CallmodelessDialog hInstance,hParent,mainDlgTabProc,addr hParent

    ret

mainDlgTab3                     endp
align 4
mainDlgTabProc                  proc hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
                                LOCAL     rect:RECT
    ;
    .if uMsg == WM_INITDIALOG
        ;
        ;*********** Horizontal TABs: TCS_SINGLELINE OR TCS_TABS
        Invoke SendMessage, hTab,TCM_GETITEMRECT,0, addr rect
        mov eax,rect.bottom
        sub eax,rect.top
        push eax
        Invoke GetClientRect,hTab, addr rect
        invoke GetSystemMetrics,SM_CXEDGE
        pop ecx        
        add eax,ecx        
        sub rect.bottom,eax
        add rect.top,eax        
        Invoke MoveWindow,hWnd,rect.left,rect.top,rect.right,rect.bottom,FALSE
        ;
        ;*********** Vertical TABs: TCS_VERTICAL OR TCS_TABS
        ;        
        ;
    .elseif uMsg == WM_CTLCOLORSTATIC
        invoke SetBkMode,wParam,TRANSPARENT     ;TRANSPARENT OPAQUE ;Background of Text
        invoke SetBkColor,wParam,0
        ;invoke SetTextColor,wParam,0E3DEDDh         ;TextColor
        invoke GetStockObject,NULL_BRUSH
        ret        
	.elseif uMsg==WM_ERASEBKGND
		mov eax, 1
		ret        
    .endif                            
    xor eax, eax
    ret
mainDlgTabProc                  endp
;
; 
; #########################################################################
; 
end start
; 
; #########################################################################
; 
;Append this to dialogs.inc
;    ; ------------------------------------
;    ; create a modeless dialog from the data
;    ; written to the memory template.
;    ; ------------------------------------
;      CallmodelessDialog MACRO Instance,Parent,DlgProc,lpExtra
;        invoke CreateDialogIndirectParam,Instance,esi,Parent,
;                                      ADDR DlgProc,lpExtra
;        push eax                ;; preserve return value
;        invoke GlobalFree,esi   ;; free memory
;        pop eax                 ;; restore return value
;        pop edi
;        pop esi
;      ENDM   